package com.engine.salary.mapper.archive;

import com.engine.salary.entity.salaryarchive.dto.SalaryArchiveListDTO;
import com.engine.salary.entity.salaryarchive.param.SalaryArchiveQueryParam;
import com.engine.salary.entity.salaryarchive.po.SalaryArchivePO;
import org.apache.ibatis.annotations.Param;

import java.util.Collection;
import java.util.List;

public interface SalaryArchiveMapper {

    /**
     * 查询所有记录
     *
     * @return 返回集合，没有返回空List
     */
    List<SalaryArchivePO> listAll();

    /**
     * 修改，修改所有字段
     *
     * @param salaryArchive 修改的记录
     * @return 返回影响行数
     */
    int update(SalaryArchivePO salaryArchive);


    /**
     * 根据主键查询
     *
     * @param id 主键
     * @return 返回记录，没有返回null
     */
    SalaryArchivePO getById(Long id);

    /**
     * 删除记录
     *
     * @param salaryArchive 待删除的记录
     * @return 返回影响行数
     */
    int delete(SalaryArchivePO salaryArchive);


    /**
     * 查询薪资档案列表
     *
     * @param param
     * @return
     */
    List<SalaryArchiveListDTO> list(@Param("param") SalaryArchiveQueryParam param);

    /**
     * 外部人员
     * @param queryParam
     * @return
     */
    List<SalaryArchiveListDTO> listExtSalaryArchive(@Param("param")SalaryArchiveQueryParam queryParam);


    /**
     * 批量插入
     *
     * @param salaryArchiveSaves
     */
    void batchInsert(@Param("collection") List<SalaryArchivePO> salaryArchiveSaves);

    /**
     * 批量更新
     *
     * @param salaryArchiveUpdates
     */
    void batchUpdate(@Param("collection") List<SalaryArchivePO> salaryArchiveUpdates);

    /**
     * 获取历史数据
     *
     * @return
     */
    List<SalaryArchivePO> getHistoryData();

    /**
     * 删除历史数据
     *
     * @param build
     * @return
     */
    void batchDeleteHistoryData(SalaryArchivePO build);

    /**
     * 条件查询
     *
     * @param param
     * @return
     */
    List<SalaryArchivePO> listSome(@Param("param") SalaryArchivePO param);


    /**
     * 获取人员状态为空的数据
     *
     * @return
     */
    List<SalaryArchivePO> getStatusIsNullData();

    /**
     * 更新状态
     *
     * @param build
     */
    void updateStatus(SalaryArchivePO build);


    void updateRunStatusByIdsAndPayEndDate(SalaryArchivePO po);

    void updateFixed(SalaryArchivePO build);

    void updateSuspend(SalaryArchivePO build);

    void gotoFixed(@Param("ids") Collection<Long> ids);

    void gotoStop(@Param("ids") Collection<Long> ids);

    void gotoPendingFromStop(@Param("ids") Collection<Long> ids);

    void gotoFixedFromStop(@Param("ids") Collection<Long> ids);

    void deletePendingTodo(@Param("ids") Collection<Long> ids);

    void deleteSuspendTodo(@Param("ids") Collection<Long> ids);

    void deleteByIds(@Param("ids")Collection<Long> deleteIds);

    List<SalaryArchivePO> listPayEndDateIsNull(@Param("ids")List<Long> employeeIds);

    List<SalaryArchivePO> listPayStartDateIsNull(@Param("runStatus")String runStatus);
}